#
print("Starting mkdataproducts.cl")

!cp ../reference/*_lim.tab ../observation
#
# set up the qpoe defaults
set qmfiles="/euve/egocs/new/etc/QPDEFS"


language 
cd ..
euv
euvred
set imdir=HDR$
cd observation


print("Getting initial table info")

tables
tinfo (	table = "table0",
	ttout = yes,
	nrows = 0,
	ncols = 0,
	npar = 0,
	rowlen = 0,
	rowused = 0,
	allrows = 0,
	maxpar = 0,
	maxcols = 0,
	tbltype = "",
	mode = "al",
	> "../reduction.check" )


# Get the stats for all of the tables
# You could do with a loop here but the colunm names complecate things

tstat (	intable = "table1",        
	column = "Table1Time",
	outtable = "t1stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t1stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t1stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )

tstat (	intable = "table2",        
	column = "Table2Time",
	outtable = "t2stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t2stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t2stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )

tstat (	intable = "table3",        
	column = "Table4Time",
	outtable = "t3stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t3stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t3stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )

tstat (	intable = "table4",        
	column = "Table8Time",
	outtable = "t4stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t4stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t4stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )

tstat (	intable = "table5",        
	column = "Table16Time",
	outtable = "t5stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t5stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t5stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )

tstat (	intable = "table6",        
	column = "Table32Time",
	outtable = "t6stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t6stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t6stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )

tstat (	intable = "table7",        
	column = "Table64Time",
	outtable = "t7stat",
	lowlim = INDEF,
	highlim = INDEF,      
        rows = "-",        
	n_tab = "table",
	n_nam = "column",   
	n_nrows = "nrows",    
	n_mean = "mean",  
	n_stddev = "stddev",
	n_median = "median",  
	n_min = "min",
	n_max = "max",     
        mode = "al" )



tprint (table = "t7stat",
	prparam = no,     
	prdata = yes,
	pwidth = 80,     
	plength = 0,     
	showrow = yes,
	showhdr = yes,   
	columns = "",   
        rows = "-", 
	option = "plain",
	align = yes,
	sp_col = "",    
	lgroup = 0,    
        mode = "al",
	>> "../reduction.check" )
     
delete	(	files = "t7stat.tab",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )



# Make the time filters based on the adc counts
#
#

print("Making good times tables")
euv
euvred
dqselect(	tables="table1",
		limits="",
		gap=1,
		format="f",
		imode="line",
		device="stdplot",
		mode="al",
		>G "meta_file" )

limload sw_lim
gtgen
gtsave sw_gt
delete det4adct
gtnew
limload mw_lim
gtgen
gtsave mw_gt
delete det5adct
gtnew
limload lw_lim
gtgen
gtsave lw_gt
delete det6adct
gtnew

display aspectw
display aspectx
display aspecty
hide all
display aspectz
display aspectt
hide all
display det4adct
display det5adct
display det6adct
hide all

q

print("Making exposure tables")

files ?w_gt%.tab%% > home$exp.list

file	*tb
char	tab

tb	="home$exp.list"

# loop over the images 

while (fscan(tb, tab) !=EOF) {
	print("Calculating exposure times for " // tab )

	tcopy (	intable = tab // ".tab",
		outtable = tab // "temp",
		verbose = yes,
		mode = "al" )

	tcalc ( table = tab // "temp",
		outcol ="delta",
		equals ="etime - stime",
		datatype = "real",
		colunits = "",
		colfmt = ".2f",
		mode = "al" )
	
	tstat (	intable = tab // "temp",        
		column = "delta",
		outtable = tab // "exp_calc",
		lowlim = INDEF,
		highlim = INDEF,      
	        rows = "-",        
		n_tab = "table",
		n_nam = "column",   
		n_nrows = "nrows",    
		n_mean = "mean",  
		n_stddev = "stddev",
		n_median = "median",  
		n_min = "min",
		n_max = "max",     
	        mode = "al" )
	
	tprint (table = tab // "exp_calc",
		prparam = no,     
		prdata = yes,
		pwidth = 80,     
		plength = 0,     
		showrow = yes,
		showhdr = yes,   
		columns = "",   
	        rows = "-", 
		option = "plain",
		align = yes,
		sp_col = "",    
		lgroup = 0,    
	        mode = "al",
		>> "../reduction.check" )
	
	
	
	tdelete	(	table = tab // "exp_calc",
			go_ahead = yes,
			verify = no,
			default_acti = yes,
			mode = "al" )
	
	
	tdelete	(	table = tab // "temp",
			go_ahead = yes,
			verify = no,
			default_acti = yes,
			mode = "al" )
	
	
	
	print("End of exp time calc for " // tab )

}
delete(	files = "home$exp.list", go_ahead = yes, verify = no,
	default_acti = yes, allversions = yes, subfiles = yes )




print ("Making meta files of dq monitors\n ")

plot
gkiextract ( 	input = "meta_file",
            	frames = 4,
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		mode = "al",
		> "aspect_file" )

gkiextract ( 	input = "meta_file",
            	frames = 7,
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		mode = "al",
		> "aspectt_file" )

gkiextract ( 	input = "meta_file",
            	frames = 11,
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		mode = "al",
		> "detadct_file" )

delete	(	files = "meta_file",
		go_ahead = yes,
		verify = no,
		default_acti = yes,
		allversions = yes,
		subfiles = yes,
		mode = "al" )



euvtools

# put the filter in to the qpoe files
# 
#

print("Making filters")

tfilter(input="sw_gt",
	output="../sw.qp",
	name="sw_gt",
	start="stime",
	end="etime",
	cmdline=no,
	format=".4f",
	mode="al" )

tfilter(input="mw_gt",
	output="../mw.qp",
	name="mw_gt",
	start="stime",
	end="etime",
	cmdline=no,
	format="f",
	mode="al" )

tfilter(input="lw_gt",
	output="../lw.qp",
	name="lw_gt",
	start="stime",
	end="etime",
	cmdline=no,
	format="f",
	mode="al" )
	



# convert the qpoe file into image files
#
#
# cd to working dir
euvtools
cd ..
# make the correct primbsch tables

print("Making the pribmsch table")

mkprimbsch  (   output = "observation/primbsch.tab",
		detectors = "sw,mw,lw",
		refdata = "reference/detector",
		infomsgs = yes,
		warnmsgs = no,
		diagmsgs = no,
		negprimb = no,
		readper = 100,
		obsdata = "observation",
		events = "table0",
		gaptimes = "table1",
		quadcts = "table2",
		ctsoffset = 1.024 )


print("Making the backmon table")
backmon	(	output = "observation/backmon",
                skip = 60,
		maxtimegap = 600,
		dodsspos = yes,
		dosatpos = yes,
		dosunpos = yes,
		doangles = yes,
		dogmpos = yes,
		domaglat = yes,
		dommjd = yes,
		dosatvel = yes,
		obsdata = "observation",
		aspect = "table1",
		refdata = "reference/detector",
		detectors = "sw",
		hdrkill = "RATE_???" )

print("Making image names")

files *%.qp%% > home$qpname.list

file	*qpn
char	name

qpn = "home$qpname.list"

while(fscan(qpn, name) != EOF) {
	
	print("Nameing image " // name )
	
	hedit (	images = name // ".qp",
		fields = "title",
		value = name,
		add = yes,
		delete = no,
		verify = no,
		show = yes,
		update = yes,
		mode = "ql"	)
}

delete(	files = "home$qpname.list", go_ahead = yes, verify = no,
	default_acti = yes, allversions = yes, subfiles = yes )




print("Making 2D images of filtered qpoe files")

images

set qmfiles="/euve/egocs/new/etc/QPDEFS"


imcopy(	input ="sw.qp[time=(sw_gt)]",
	output ="sw.imh",
	verbose = yes )

imcopy(	input ="mw.qp[time=(mw_gt)]",
	output ="mw.imh",
	verbose = yes )

imcopy(	input ="lw.qp[time=(lw_gt)]",
	output ="lw.imh",
	verbose = yes )


imcopy(	input ="sw.qp[key=(dx,dy),time=(sw_gt)]",
	output ="sw_det.imh",
	verbose = yes )

imcopy(	input ="mw.qp[key=(dx,dy),time=(mw_gt)]",
	output ="mw_det.imh",
	verbose = yes )

imcopy(	input ="lw.qp[key=(dx,dy),time=(lw_gt)]",
	output ="lw_det.imh",
	verbose = yes )





# extract the spectra from the image files
#
#
print("Extracting spectra from 2D images")

set imdir=HDR$

files ?w%.imh%% > home$qpoe.list

file	*qp
char	name

qp	="home$qpoe.list"

# loop over the images 

while (fscan(qp, name) !=EOF) {
	print("Making extracted spectra " // name )


	euvextract(	input= name // ".imh",
			output= name // "_spec.imh",
			swcs="physical",
			scenter=1024,
			swidth=10,
			bwcs="physical",
			bcenter=1060,
			bwidth=50,
			verbose=yes,
			mode="al" )

	print("Made extracted spectra" // name )

}

delete(	files = "home$qpoe.list", go_ahead = yes, verify = no,
	default_acti = yes, allversions = yes, subfiles = yes )



print("Making meta files for the extracted spectra")

noao
onedspec

files ?w_spec%.imh%% > home$spec.list

file	*sp
char	spec

sp	="home$spec.list"

# loop over the images 

while (fscan(sp, spec) !=EOF) {
	print("Making extracted spectra meta files " // spec )

	graph (	input = spec // ".imh",
		wx1 = 0.,
		wx2 = 0.,
		wy1 = 0.,
		wy2 = 0.,
		wcs = "world",
		axis = 1,
		transpose = no,
		pointmode = no,
		marker = "box",
		szmarker = 0.005,
		logy = no,
		box = yes,
		ticklabels = yes,
		xlabel = "wcslabel",
		ylabel = "",
		xformat = "wcsformat",
		yformat = "",
		title = "imtitle",
		lintran = no,
		p1 = 0.,
		p2 = 0.,
		q1 = 0.,
		q2 = 1.,
		vx1 = 0.,
		vx2 = 0.,
		vy1 = 0.,
		vy2 = 0.,
		majrx = 5,
		minrx = 5,
		majry = 5,
		minry = 5,
		overplot = no,
		append = no,
		device = "stdplot",
		round = no,
		fill = yes,
		mode = "ql",
		>G spec // "_file" )


	print("Made extracted spectra file " // spec )

}

delete(	files = "home$spec.list", go_ahead = yes, verify = no,
	default_acti = yes, allversions = yes, subfiles = yes )


print("Getting events from qpoe headers")

images
imhead *.qp lo+ userfields+ | match EVENTS >> reduction.check

print("Dumping filters to text file")

euvtools
qpmedit ( 	files = "*.qp",
		macros = "*",
		value = ".",
		add = no,
		delete = no,
		verify = no,
		show = yes,
		update = no,
		mode = "al",
		>> "reduction.check" )


# logout

logout
