# H+
#	Title	: unfits.cl
#	Author	: Tom Kilsdonk
#	Date	: 7/30/93
#	Synopsis: batch file to unFITS reference data set files
#	Keywords: EGODATA
#
# 	@(#)unfits.cl	1.1 7/30/93 UCB CEA EGO
#
#	Revisions:
#	mm/dd/yy name	description
# H-
# U+
# 	Usage	: unfits
# 	Input	:
# 	Output	:
# U-
# D+
#
#	
# D-

tables

set imdir = HDR$

#  unfits all the *.FITS files in the current directory.
#  Do them one at a time, due to a possible strfits bug
#  that deletes WCS cards from images when they are unFITS'd
#  after tables.

files *.FITS > home$fits.list

file	*fp
char	filename

fp = "home$fits.list"

while (fscan(fp, filename) != EOF) {
	strfits(fits_file = filename,
                file_list = "",
                iraf_file = "",
	 	oldirafname = yes,
		xdimtogf = no)
}


#	General clean up

del home$fits.list

